diff --git a/distrib/utils/sysinst/arch/newsmips/md.c b/distrib/utils/sysinst/arch/newsmips/md.c
index 11e4163..030cbef 100644
--- a/distrib/utils/sysinst/arch/newsmips/md.c
+++ b/distrib/utils/sysinst/arch/newsmips/md.c
@@ -63,11 +63,11 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	snprintf (dev_name, 100, "/dev/r%sc", diskdev);
+	snprintf (dev_name, 100, "/dev/r%sc", pm->diskdev);
 
 	fd = open (dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -75,7 +75,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -83,21 +83,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -150,11 +150,11 @@ md_post_newfs()
 {
 	const char *bootfile = "/boot";
 
-	printf (msg_string(MSG_dobootblks), diskdev);
+	printf (msg_string(MSG_dobootblks), pm->diskdev);
 	cp_to_target("/usr/mdec/boot", bootfile);
 	sync();
 	run_program(RUN_DISPLAY, "/usr/sbin/installboot /dev/r%sc %s %s",
-	    diskdev, "/usr/mdec/bootxx", bootfile);
+	    pm->diskdev, "/usr/mdec/bootxx", bootfile);
 	return 0;
 }
 
diff --git a/distrib/utils/sysinst/arch/ofppc/md.c b/distrib/utils/sysinst/arch/ofppc/md.c
index 0ff9339..d522ee6 100644
--- a/distrib/utils/sysinst/arch/ofppc/md.c
+++ b/distrib/utils/sysinst/arch/ofppc/md.c
@@ -101,28 +101,28 @@ md_make_bsd_partitions(void)
 	if (rdb_found) {
 		/*
 		 * We found RDB partitions on the disk, which cannot be
-		 * modified by rewriting the disklabel.
+		 * modified by rewriting the pm->disklabel.
 		 * So just use what we have got.
 		 */
 		for (part = 0; part < maxpart; part++) {
-			if (PI_ISBSDFS(&bsdlabel[part])) {
-				bsdlabel[part].pi_flags |=
+			if (PI_ISBSDFS(&pm->bsdlabel[part])) {
+				pm->bsdlabel[part].pi_flags |=
 				    PIF_NEWFS | PIF_MOUNT;
 
 				if (part == PART_A)
-					strcpy(bsdlabel[part].pi_mount, "/");
+					strcpy(pm->bsdlabel[part].pi_mount, "/");
 			}
 		}
 
 		part_bsd = part_raw = getrawpartition();
 		if (part_raw == -1)
 			part_raw = PART_C;	/* for sanity... */
-		bsdlabel[part_raw].pi_offset = 0;
-		bsdlabel[part_raw].pi_size = dlsize;
+		pm->bsdlabel[part_raw].pi_offset = 0;
+		pm->bsdlabel[part_raw].pi_size = pm->dlsize;
 
 		set_sizemultname_meg();
 rdb_edit_check:
-		if (edit_and_check_label(bsdlabel, maxpart, part_raw,
+		if (edit_and_check_label(pm->bsdlabel, maxpart, part_raw,
 		    part_bsd) == 0) {
 			msg_display(MSG_abort);
 			return 0;
@@ -137,72 +137,72 @@ rdb_edit_check:
 	 * Initialize global variables that track space used on this disk.
 	 * Standard 4.4BSD 8-partition labels always cover whole disk.
 	 */
-	if (ptsize == 0)
-		ptsize = dlsize - ptstart;
-	if (dlsize == 0)
-		dlsize = ptstart + ptsize;
+	if (pm->ptsize == 0)
+		pm->ptsize = pm->dlsize - pm->ptstart;
+	if (pm->dlsize == 0)
+		pm->dlsize = pm->ptstart + pm->ptsize;
 
-	partstart = ptstart;
-	ptend = ptstart + ptsize;
+	partstart = pm->ptstart;
+	ptend = pm->ptstart + pm->ptsize;
 
 	/* Ask for layout type -- standard or special */
 	msg_display(MSG_layout,
-		    ptsize / (MEG / sectorsize),
+		    pm->ptsize / (MEG / pm->sectorsize),
 		    DEFROOTSIZE + DEFSWAPSIZE + DEFUSRSIZE,
 		    DEFROOTSIZE + DEFSWAPSIZE + DEFUSRSIZE + XNEEDMB);
 
 	process_menu(MENU_layout, NULL);
 
 	/* Set so we use the 'real' geometry for rounding, input in MB */
-	current_cylsize = dlcylsize;
+	pm->current_cylsize = pm->dlcylsize;
 	set_sizemultname_meg();
 
 	/* Build standard partitions */
-	memset(&bsdlabel, 0, sizeof bsdlabel);
+	memset(&pm->bsdlabel, 0, sizeof pm->bsdlabel);
 
 	/* Set initial partition types to unused */
 	for (part = 0 ; part < maxpart ; ++part)
-		bsdlabel[part].pi_fstype = FS_UNUSED;
+		pm->bsdlabel[part].pi_fstype = FS_UNUSED;
 
 	/* Whole disk partition */
 	part_raw = getrawpartition();
 	if (part_raw == -1)
 		part_raw = PART_C;	/* for sanity... */
-	bsdlabel[part_raw].pi_offset = 0;
-	bsdlabel[part_raw].pi_size = dlsize;
+	pm->bsdlabel[part_raw].pi_offset = 0;
+	pm->bsdlabel[part_raw].pi_size = pm->dlsize;
 
 	if (part_raw == PART_D) {
 		/* Probably a system that expects an i386 style mbr */
 		part_bsd = PART_C;
-		bsdlabel[PART_C].pi_offset = ptstart;
-		bsdlabel[PART_C].pi_size = ptsize;
+		pm->bsdlabel[PART_C].pi_offset = pm->ptstart;
+		pm->bsdlabel[PART_C].pi_size = pm->ptsize;
 	} else {
 		part_bsd = part_raw;
 	}
 
-	if (bootsize != 0) {
-		bsdlabel[PART_BOOT_FAT12].pi_fstype = FS_MSDOS;
-		bsdlabel[PART_BOOT_FAT12].pi_size = bootsize;
-		bsdlabel[PART_BOOT_FAT12].pi_offset = bootstart;
-		bsdlabel[PART_BOOT_FAT12].pi_flags |= PART_BOOT_FAT12_PI_FLAGS;
-		strlcpy(bsdlabel[PART_BOOT_FAT12].pi_mount,
+	if (pm->bootsize != 0) {
+		pm->bsdlabel[PART_BOOT_FAT12].pi_fstype = FS_MSDOS;
+		pm->bsdlabel[PART_BOOT_FAT12].pi_size = pm->bootsize;
+		pm->bsdlabel[PART_BOOT_FAT12].pi_offset = pm->bootstart;
+		pm->bsdlabel[PART_BOOT_FAT12].pi_flags |= PART_BOOT_FAT12_PI_FLAGS;
+		strlcpy(pm->bsdlabel[PART_BOOT_FAT12].pi_mount,
 		    PART_BOOT_FAT12_PI_MOUNT,
-		    sizeof bsdlabel[PART_BOOT_FAT12].pi_mount);
+		    sizeof pm->bsdlabel[PART_BOOT_FAT12].pi_mount);
 	}
 	if (binfosize != 0) {
-		bsdlabel[PART_BOOT_BINFO].pi_fstype = FS_OTHER;
-		bsdlabel[PART_BOOT_BINFO].pi_size = binfosize;
-		bsdlabel[PART_BOOT_BINFO].pi_offset = binfostart;
+		pm->bsdlabel[PART_BOOT_BINFO].pi_fstype = FS_OTHER;
+		pm->bsdlabel[PART_BOOT_BINFO].pi_size = binfosize;
+		pm->bsdlabel[PART_BOOT_BINFO].pi_offset = binfostart;
 	}
 	if (bprepsize != 0) {
-		bsdlabel[PART_BOOT_PREP].pi_fstype = FS_BOOT;
-		bsdlabel[PART_BOOT_PREP].pi_size = bprepsize;
-		bsdlabel[PART_BOOT_PREP].pi_offset = bprepstart;
+		pm->bsdlabel[PART_BOOT_PREP].pi_fstype = FS_BOOT;
+		pm->bsdlabel[PART_BOOT_PREP].pi_size = bprepsize;
+		pm->bsdlabel[PART_BOOT_PREP].pi_offset = bprepstart;
 	}
 
 #ifdef PART_REST
-	bsdlabel[PART_REST].pi_offset = 0;
-	bsdlabel[PART_REST].pi_size = ptstart;
+	pm->bsdlabel[PART_REST].pi_offset = 0;
+	pm->bsdlabel[PART_REST].pi_size = pm->ptstart;
 #endif
 
 	/*
@@ -212,24 +212,24 @@ rdb_edit_check:
 	 * partitions on a multiboot i386 system.
 	 */
 	 for (i = maxpart; i--;) {
-		if (bsdlabel[i].pi_size != 0)
+		if (pm->bsdlabel[i].pi_size != 0)
 			/* Don't overwrite special partitions */
 			continue;
-		p = &oldlabel[i];
+		p = &pm->oldlabel[i];
 		if (p->pi_fstype == FS_UNUSED || p->pi_size == 0)
 			continue;
 		if (layoutkind == 4) {
 			if (PI_ISBSDFS(p))
 				p->pi_flags |= PIF_MOUNT;
 		} else {
-			if (p->pi_offset < ptstart + ptsize &&
-			    p->pi_offset + p->pi_size > ptstart)
+			if (p->pi_offset < pm->ptstart + pm->ptsize &&
+			    p->pi_offset + p->pi_size > pm->ptstart)
 				/* Not outside area we are allocating */
 				continue;
 			if (p->pi_fstype == FS_SWAP)
 				no_swap = 1;
 		}
-		bsdlabel[i] = oldlabel[i];
+		pm->bsdlabel[i] = pm->oldlabel[i];
 	 }
 
 	if (layoutkind == 4) {
@@ -243,7 +243,7 @@ rdb_edit_check:
 	 * edit it and verify it's OK, or abort altogether.
 	 */
  edit_check:
-	if (edit_and_check_label(bsdlabel, maxpart, part_raw, part_bsd) == 0) {
+	if (edit_and_check_label(pm->bsdlabel, maxpart, part_raw, part_bsd) == 0) {
 		msg_display(MSG_abort);
 		return 0;
 	}
@@ -251,10 +251,10 @@ rdb_edit_check:
 		goto edit_check;
 
 	/* Disk name */
-	msg_prompt(MSG_packname, bsddiskname, bsddiskname, sizeof bsddiskname);
+	msg_prompt(MSG_packname, pm->bsddiskname, pm->bsddiskname, sizeof pm->bsddiskname);
 
 	/* save label to disk for MI code to update. */
-	(void) savenewlabel(bsdlabel, maxpart);
+	(void) savenewlabel(pm->bsdlabel, maxpart);
 
 	/* Everything looks OK. */
 	return 1;
@@ -277,13 +277,13 @@ md_check_partitions(void)
 	 * from the MBR partition.
 	 */
 	for (part = PART_A; part < MAXPARTITIONS; part++) {
-		if (bsdlabel[part].pi_fstype == FS_MSDOS) {
+		if (pm->bsdlabel[part].pi_fstype == FS_MSDOS) {
 			bootpart_fat12 = part;
 			ffat++;
-		} else if (bsdlabel[part].pi_fstype == FS_BOOT) {
+		} else if (pm->bsdlabel[part].pi_fstype == FS_BOOT) {
 			bootpart_prep = part;
 			fprep++;
-		} else if (bsdlabel[part].pi_fstype == FS_OTHER) {
+		} else if (pm->bsdlabel[part].pi_fstype == FS_OTHER) {
 			bootpart_binfo = part;
 			fprep++;
 		}
@@ -314,7 +314,7 @@ md_pre_disklabel(void)
 	msg_display(MSG_dofdisk);
 
 	/* write edited MBR onto disk. */
-	if (write_mbr(diskdev, &mbr, 1) != 0) {
+	if (write_mbr(pm->diskdev, &mbr, 1) != 0) {
 		msg_display(MSG_wmbrfail);
 		process_menu(MENU_ok, NULL);
 		return 1;
@@ -330,10 +330,10 @@ md_post_disklabel(void)
 {
 	char bootdev[100];
 
-	if (bootstart == 0 || bootsize == 0 || rdb_found)
+	if (pm->bootstart == 0 || pm->bootsize == 0 || rdb_found)
 		return 0;
 
-	snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", diskdev,
+	snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", pm->diskdev,
 	    'a'+bootpart_fat12);
 	run_program(RUN_DISPLAY, "/sbin/newfs_msdos %s", bootdev);
 
@@ -380,18 +380,18 @@ md_post_extract(void)
 	}
 
 	if (!noprepfix) {
-		snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", diskdev,
+		snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", pm->diskdev,
 		    'a'+bootpart_prep);
-		snprintf(bootbdev, sizeof bootbdev, "/dev/%s%c", diskdev,
+		snprintf(bootbdev, sizeof bootbdev, "/dev/%s%c", pm->diskdev,
 		    'a'+bootpart_prep);
 		run_program(RUN_DISPLAY, "/bin/dd if=/dev/zero of=%s bs=512",
 		    bootdev);
 		run_program(RUN_DISPLAY, "/bin/dd if=/usr/mdec/ofwboot "
 		    "of=%s bs=512", bootbdev);
 
-		snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", diskdev,
+		snprintf(bootdev, sizeof bootdev, "/dev/r%s%c", pm->diskdev,
 		    'a'+bootpart_binfo);
-		snprintf(bootbdev, sizeof bootbdev, "/dev/%s%c", diskdev,
+		snprintf(bootbdev, sizeof bootbdev, "/dev/%s%c", pm->diskdev,
 		    'a'+bootpart_binfo);
 		run_program(RUN_DISPLAY, "/bin/dd if=/dev/zero of=%s bs=512",
 		    bootdev);
@@ -421,7 +421,7 @@ md_pre_update(void)
 	if (check_rdb())
 		return 1;
 
-	read_mbr(diskdev, &mbr);
+	read_mbr(pm->diskdev, &mbr);
 	/* do a sanity check of the partition table */
 	for (ext = &mbr; ext; ext = ext->extended) {
 		part = ext->mbr.mbr_parts;
@@ -474,8 +474,8 @@ md_check_mbr(mbr_info_t *mbri)
 		part = ext->mbr.mbr_parts;
 		for (i = 0; i < MBR_PART_COUNT; part++, i++) {
 			if (part->mbrp_type == MBR_PTYPE_FAT12) {
-				bootstart = part->mbrp_start;
-				bootsize = part->mbrp_size;
+				pm->bootstart = part->mbrp_start;
+				pm->bootsize = part->mbrp_size;
 			} else if (part->mbrp_type == MBR_PTYPE_PREP &&
 			    part->mbrp_size < 50) {
 				/* this is the bootinfo partition */
@@ -493,7 +493,7 @@ md_check_mbr(mbr_info_t *mbri)
 
 	/* we need to either have a pair of prep partitions, or a single
 	 * fat.  if neither, things are broken. */
-	if (!(bootsize >= (MIN_FAT12_BOOT/512) ||
+	if (!(pm->bootsize >= (MIN_FAT12_BOOT/512) ||
 		(binfosize >= (MIN_BINFO_BOOT/512) &&
 		    bprepsize >= (MIN_PREP_BOOT/512)))) {
 		msg_display(MSG_bootnotright);
@@ -517,7 +517,7 @@ md_check_mbr(mbr_info_t *mbri)
 	}
 
 	/* check the fat12 parititons */
-	if (bootsize > 0 && bootsize < (MIN_FAT12_BOOT/512)) {
+	if (pm->bootsize > 0 && pm->bootsize < (MIN_FAT12_BOOT/512)) {
 		msg_display(MSG_boottoosmall);
 		msg_display_add(MSG_reeditpart, 0);
 		process_menu(MENU_yesno, NULL);
@@ -527,7 +527,7 @@ md_check_mbr(mbr_info_t *mbri)
 	}
 
 	/* if both sets contain zero, thats bad */
-	if ((bootstart == 0 || bootsize == 0) &&
+	if ((pm->bootstart == 0 || pm->bootsize == 0) &&
 	    (binfosize == 0 || binfostart == 0 ||
 		bprepsize == 0 || bprepstart == 0)) {
 		msg_display(MSG_nobootpart);
@@ -571,7 +571,7 @@ md_mbr_use_wholedisk(mbr_info_t *mbri)
 	part[0].mbrp_flag = 0;
 
 	part[1].mbrp_type = MBR_PTYPE_NETBSD;
-	part[1].mbrp_size = dlsize - (bsec + FAT12_BOOT_SIZE/512 +
+	part[1].mbrp_size = pm->dlsize - (bsec + FAT12_BOOT_SIZE/512 +
 	    BINFO_BOOT_SIZE/512 + PREP_BOOT_SIZE/512);
 	part[1].mbrp_start = bsec + FAT12_BOOT_SIZE/512 + BINFO_BOOT_SIZE/512 +
 	    PREP_BOOT_SIZE/512;
@@ -587,10 +587,10 @@ md_mbr_use_wholedisk(mbr_info_t *mbri)
 	part[3].mbrp_start = bsec + FAT12_BOOT_SIZE/512 + BINFO_BOOT_SIZE/512;
 	part[3].mbrp_flag = 0;
 
-	ptstart = part[1].mbrp_start;
-	ptsize = part[1].mbrp_size;
-	bootstart = part[0].mbrp_start;
-	bootsize = part[0].mbrp_size;
+	pm->ptstart = part[1].mbrp_start;
+	pm->ptsize = part[1].mbrp_size;
+	pm->bootstart = part[0].mbrp_start;
+	pm->bootsize = part[0].mbrp_size;
 	binfostart = part[2].mbrp_start;
 	binfosize= part[2].mbrp_size;
 	bprepstart = part[3].mbrp_start;
@@ -620,7 +620,7 @@ check_rdb(void)
 
 	/* Find out if this disk has a valid RDB, before continuing. */
 	rdb = (struct rdblock *)buf;
-	fd = opendisk(diskdev, O_RDONLY, diskpath, sizeof(diskpath), 0);
+	fd = opendisk(pm->diskdev, O_RDONLY, diskpath, sizeof(diskpath), 0);
 	if (fd < 0)
 		return 0;
 	for (blk = 0; blk < RDB_MAXBLOCKS; blk++) {
diff --git a/distrib/utils/sysinst/arch/pmax/md.c b/distrib/utils/sysinst/arch/pmax/md.c
index e8bd354..19aabd8 100644
--- a/distrib/utils/sysinst/arch/pmax/md.c
+++ b/distrib/utils/sysinst/arch/pmax/md.c
@@ -62,11 +62,11 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	snprintf(dev_name, 100, "/dev/r%sc", diskdev);
+	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
 	fd = open(dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -76,7 +76,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -87,21 +87,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -161,12 +161,12 @@ md_post_newfs(void)
 		return 0;
 	}
 
-	printf(msg_string(MSG_dobootblks), diskdev);
+	printf(msg_string(MSG_dobootblks), pm->diskdev);
 	cp_to_target("/usr/mdec/boot.pmax", "/boot.pmax");
 	bootxx = bootxx_name();
 	if (bootxx != NULL) {
 		error = run_program(RUN_DISPLAY | RUN_NO_CLEAR,
-		    "/usr/sbin/installboot /dev/r%sc %s", diskdev, bootxx);
+		    "/usr/sbin/installboot /dev/r%sc %s", pm->diskdev, bootxx);
 		free(bootxx);
 	} else
 		error = -1;
diff --git a/distrib/utils/sysinst/arch/prep/md.c b/distrib/utils/sysinst/arch/prep/md.c
index 36fd490..0d36771 100644
--- a/distrib/utils/sysinst/arch/prep/md.c
+++ b/distrib/utils/sysinst/arch/prep/md.c
@@ -87,7 +87,7 @@ md_check_partitions(void)
 	 * something stupid, like move it away from the MBR partition.
 	 */
 	for (part = PART_A; part < MAXPARTITIONS; part++)
-		if (bsdlabel[part].pi_fstype == FS_BOOT) {
+		if (pm->bsdlabel[part].pi_fstype == FS_BOOT) {
 			prep_bootpart = part;
 			return 1;
 		}
@@ -106,7 +106,7 @@ md_pre_disklabel(void)
 	msg_display(MSG_dofdisk);
 
 	/* write edited MBR onto disk. */
-	if (write_mbr(diskdev, &mbr, 1) != 0) {
+	if (write_mbr(pm->diskdev, &mbr, 1) != 0) {
 		msg_display(MSG_wmbrfail);
 		process_menu(MENU_ok, NULL);
 		return 1;
@@ -149,8 +149,8 @@ md_post_extract(void)
 	else
 		snprintf(bootloader, 100, "/usr/mdec/boot");
 
-	snprintf(rawdev, 100, "/dev/r%s%c", diskdev, 'a' + getrawpartition());
-	snprintf(bootpart, 100, "/dev/r%s%c", diskdev, 'a' + prep_bootpart);
+	snprintf(rawdev, 100, "/dev/r%s%c", pm->diskdev, 'a' + getrawpartition());
+	snprintf(bootpart, 100, "/dev/r%s%c", pm->diskdev, 'a' + prep_bootpart);
 	if (prep_rawdevfix)
 		run_program(RUN_DISPLAY|RUN_CHROOT,
 		    "/usr/mdec/mkbootimage -b %s -k /netbsd "
@@ -181,7 +181,7 @@ md_pre_update(void)
 	mbr_info_t *ext;
 	int i;
 
-	read_mbr(diskdev, &mbr);
+	read_mbr(pm->diskdev, &mbr);
 	/* do a sanity check of the partition table */
 	for (ext = &mbr; ext; ext = ext->extended) {
 		part = ext->mbr.mbr_parts;
@@ -225,12 +225,12 @@ md_check_mbr(mbr_info_t *mbri)
 		for (i = 0; i < MBR_PART_COUNT; part++, i++) {
 			if (part->mbrp_type != MBR_PTYPE_PREP)
 				continue;
-			bootstart = part->mbrp_start;
-			bootsize = part->mbrp_size;
+			pm->bootstart = part->mbrp_start;
+			pm->bootsize = part->mbrp_size;
 			break;
 		}
 	}
-	if (bootsize < (MIN_PREP_BOOT/512)) {
+	if (pm->bootsize < (MIN_PREP_BOOT/512)) {
 		msg_display(MSG_preptoosmall);
 		msg_display_add(MSG_reeditpart, 0);
 		process_menu(MENU_yesno, NULL);
@@ -238,7 +238,7 @@ md_check_mbr(mbr_info_t *mbri)
 			return 0;
 		return 1;
 	}
-	if (bootstart == 0 || bootsize == 0) {
+	if (pm->bootstart == 0 || pm->bootsize == 0) {
 		msg_display(MSG_nopreppart);
 		msg_display_add(MSG_reeditpart, 0);
 		process_menu(MENU_yesno, NULL);
@@ -272,14 +272,14 @@ md_mbr_use_wholedisk(mbr_info_t *mbri)
 	part[0].mbrp_flag = MBR_PFLAG_ACTIVE;
 
 	part[1].mbrp_type = MBR_PTYPE_NETBSD;
-	part[1].mbrp_size = dlsize - (bsec + PREP_BOOT_SIZE/512);
+	part[1].mbrp_size = pm->dlsize - (bsec + PREP_BOOT_SIZE/512);
 	part[1].mbrp_start = bsec + PREP_BOOT_SIZE/512;
 	part[1].mbrp_flag = 0;
 
-	ptstart = part[1].mbrp_start;
-	ptsize = part[1].mbrp_size;
-	bootstart = part[0].mbrp_start;
-	bootsize = part[0].mbrp_size;
+	pm->ptstart = part[1].mbrp_start;
+	pm->ptsize = part[1].mbrp_size;
+	pm->bootstart = part[0].mbrp_start;
+	pm->bootsize = part[0].mbrp_size;
 	return 1;
 }
 
diff --git a/distrib/utils/sysinst/arch/sandpoint/md.c b/distrib/utils/sysinst/arch/sandpoint/md.c
index 5872e39..fc42a72 100644
--- a/distrib/utils/sysinst/arch/sandpoint/md.c
+++ b/distrib/utils/sysinst/arch/sandpoint/md.c
@@ -122,7 +122,7 @@ md_pre_disklabel(void)
 	printf ("%s", msg_string (MSG_dofdisk));
 
 	/* write edited MBR onto disk. */
-	if (write_mbr(diskdev, &mbr, 1) != 0) {
+	if (write_mbr(pm->diskdev, &mbr, 1) != 0) {
 		msg_display(MSG_wmbrfail);
 		process_menu(MENU_ok, NULL);
 		return 1;
@@ -140,7 +140,7 @@ md_post_disklabel(void)
 	if (*doessf) {
 		printf ("%s", msg_string (MSG_dobad144));
 		return run_program(RUN_DISPLAY, "/usr/sbin/bad144 %s 0",
-		    diskdev);
+		    pm->diskdev);
 	}
 	return 0;
 }
diff --git a/distrib/utils/sysinst/arch/sgimips/md.c b/distrib/utils/sysinst/arch/sgimips/md.c
index bece141..98d7897 100644
--- a/distrib/utils/sysinst/arch/sgimips/md.c
+++ b/distrib/utils/sysinst/arch/sgimips/md.c
@@ -79,11 +79,11 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	snprintf(dev_name, 100, "/dev/r%s%c", diskdev, 'a' + getrawpartition());
+	snprintf(dev_name, 100, "/dev/r%s%c", pm->diskdev, 'a' + getrawpartition());
 
 	fd = open(dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -93,7 +93,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -104,21 +104,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -156,19 +156,19 @@ md_pre_disklabel(void)
 int
 md_post_disklabel(void)
 {
-	set_swap(diskdev, bsdlabel);
-        if (strstr(instsys.version, "(INSTALL32_IP3x)"))
+	set_swap(pm->diskdev, pm->bsdlabel);
+    if (strstr(instsys.version, "(INSTALL32_IP3x)"))
 		return run_program(RUN_DISPLAY,
 		    "%s %s", "/usr/mdec/sgivol -f -w boot /usr/mdec/ip3xboot",
-		    diskdev);
+		    pm->diskdev);
 
 	if (strstr(instsys.version, "(INSTALL32_IP2x)")) {
 		run_program(RUN_DISPLAY,
 		  "%s %s", "/usr/mdec/sgivol -f -w aoutboot /usr/mdec/aoutboot",
-		  diskdev);
+		  pm->diskdev);
 		return run_program(RUN_DISPLAY,
 		  "%s %s", "/usr/mdec/sgivol -f -w boot /usr/mdec/ip2xboot",
-		  diskdev);
+		  pm->diskdev);
 	}
 
 	/* Presumably an IP12, we add the boot code later... */
@@ -201,7 +201,7 @@ md_cleanup_install(void)
 
 	if (strstr(instsys.version, "(GENERIC32_IP12)"))
 		run_program(0, "/usr/mdec/sgivol -f -w netbsd %s %s",
-			    target_expand("/netbsd.ecoff"), diskdev);
+			    target_expand("/netbsd.ecoff"), pm->diskdev);
 }
 
 int
diff --git a/distrib/utils/sysinst/arch/sgimips/md.h b/distrib/utils/sysinst/arch/sgimips/md.h
index 92be0d4..d51ce67 100644
--- a/distrib/utils/sysinst/arch/sgimips/md.h
+++ b/distrib/utils/sysinst/arch/sgimips/md.h
@@ -63,7 +63,7 @@
  * hand-edited disklabel will NOT be written by MI code.
  */
 /*
- * sgimips should not use -r, as this prevents the SGI disklabel
+ * sgimips should not use -r, as this prevents the SGI pm->disklabel
  * from being written.
  */
 #define DISKLABEL_CMD "disklabel -w"
diff --git a/distrib/utils/sysinst/arch/shark/md.c b/distrib/utils/sysinst/arch/shark/md.c
index 070336a..593f6ca 100644
--- a/distrib/utils/sysinst/arch/shark/md.c
+++ b/distrib/utils/sysinst/arch/shark/md.c
@@ -65,16 +65,16 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	if (strncmp(diskdev, "wd", 2) == 0)
+	if (strncmp(pm->diskdev, "wd", 2) == 0)
 		disktype = "ST506";
 	else
 		disktype = "SCSI";
 
-	snprintf(dev_name, 100, "/dev/r%sc", diskdev);
+	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
 	fd = open(dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -82,7 +82,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		endwin();
 		fprintf(stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -90,21 +90,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -135,7 +135,7 @@ md_pre_disklabel(void)
 {
 	char diskpath[MAXPATHLEN];
 
-	if (clear_mbr(diskdev, diskpath, sizeof(diskpath)) == -1) {
+	if (clear_mbr(pm->diskdev, diskpath, sizeof(diskpath)) == -1) {
 		msg_display(MSG_badclearmbr, diskpath);
 		process_menu(MENU_ok, NULL);
 	}
diff --git a/distrib/utils/sysinst/arch/sparc/md.c b/distrib/utils/sysinst/arch/sparc/md.c
index 6934ed6..1fa8360 100644
--- a/distrib/utils/sysinst/arch/sparc/md.c
+++ b/distrib/utils/sysinst/arch/sparc/md.c
@@ -68,11 +68,11 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	snprintf(dev_name, 100, "/dev/r%s%c", diskdev, 'a' + getrawpartition());
+	snprintf(dev_name, 100, "/dev/r%s%c", pm->diskdev, 'a' + getrawpartition());
 
 	fd = open(dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -82,7 +82,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -93,21 +93,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -160,8 +160,8 @@ md_post_newfs(void)
 {
 
 	/* boot blocks ... */
-	msg_display(MSG_dobootblks, diskdev);
-	return (run_program(RUN_DISPLAY, "/sbin/disklabel -W %s", diskdev) ||
+	msg_display(MSG_dobootblks, pm->diskdev);
+	return (run_program(RUN_DISPLAY, "/sbin/disklabel -W %s", pm->diskdev) ||
 	    run_program(RUN_DISPLAY, "/usr/mdec/binstall ffs %s",
 		targetroot_mnt));
 }
diff --git a/distrib/utils/sysinst/arch/sparc64/md.c b/distrib/utils/sysinst/arch/sparc64/md.c
index f4ab543..7a1152f 100644
--- a/distrib/utils/sysinst/arch/sparc64/md.c
+++ b/distrib/utils/sysinst/arch/sparc64/md.c
@@ -69,11 +69,11 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct disklabel disklabel;
+	struct pm->disklabel pm->disklabel;
 	int fd;
 	char dev_name[100];
 
-	snprintf(dev_name, 100, "/dev/r%sc", diskdev);
+	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
 	fd = open(dev_name, O_RDONLY, 0);
 	if (fd < 0) {
@@ -83,7 +83,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -94,21 +94,21 @@ md_get_info(void)
 	}
 	close(fd);
 
-	dlcyl = disklabel.d_ncylinders;
-	dlhead = disklabel.d_ntracks;
-	dlsec = disklabel.d_nsectors;
-	sectorsize = disklabel.d_secsize;
-	dlcylsize = disklabel.d_secpercyl;
+	pm->dlcyl = pm->disklabel.d_ncylinders;
+	pm->dlhead = pm->disklabel.d_ntracks;
+	pm->dlsec = pm->disklabel.d_nsectors;
+	pm->sectorsize = pm->disklabel.d_secsize;
+	pm->dlcylsize = pm->disklabel.d_secpercyl;
 
 	/*
-	 * Compute whole disk size. Take max of (dlcyl*dlhead*dlsec)
+	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
 	 * and secperunit,  just in case the disk is already labelled.
 	 * (If our new label's RAW_PART size ends up smaller than the
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
-	dlsize = dlcyl*dlhead*dlsec;
-	if (disklabel.d_secperunit > dlsize)
-		dlsize = disklabel.d_secperunit;
+	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
+	if (pm->disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = pm->disklabel.d_secperunit;
 
 	return 1;
 }
@@ -195,10 +195,10 @@ static void
 install_bootblocks(void)
 {
 	/* Install boot blocks before mounting the target disk */
-	msg_display(MSG_dobootblks, diskdev);
-	run_program(RUN_DISPLAY, "/sbin/disklabel -W %s", diskdev);
+	msg_display(MSG_dobootblks, pm->diskdev);
+	run_program(RUN_DISPLAY, "/sbin/disklabel -W %s", pm->diskdev);
 	run_program(RUN_DISPLAY, "/usr/sbin/installboot /dev/r%sc"
-	    " /usr/mdec/bootblk", diskdev);
+	    " /usr/mdec/bootblk", pm->diskdev);
 }
 
 /* install/update secondary bootstrap */
